const path = require('path');
const pluginName = 'awscloudformation';
async function executeAmplifyCommand(context) {
    let commandPath = path.normalize(path.join(__dirname, 'commands'));
    if (context.input.command === 'help') {
        commandPath = path.join(commandPath, pluginName);
    }
    else {
        commandPath = path.join(commandPath, pluginName, context.input.command);
    }
    const commandModule = require(commandPath);
    await commandModule.run(context);
}
async function handleAmplifyEvent(context, args) {
    context.print.info(`${pluginName} handleAmplifyEvent to be implemented`);
    context.print.info(`Received event args ${args}`);
}
module.exports = {
    executeAmplifyCommand,
    handleAmplifyEvent,
};
//# sourceMappingURL=amplify-plugin-index.js.map