"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CognitoUserPoolClientProvider = void 0;
const aws_js_1 = __importDefault(require("./aws.js"));
const configuration_manager_1 = require("../configuration-manager");
class CognitoUserPoolClientProvider {
    static async getInstance(context, options = {}) {
        if (!CognitoUserPoolClientProvider.instance) {
            let cred = {};
            try {
                cred = await (0, configuration_manager_1.loadConfiguration)(context);
            }
            catch (e) {
            }
            CognitoUserPoolClientProvider.instance = new CognitoUserPoolClientProvider(cred, options);
        }
        return CognitoUserPoolClientProvider.instance;
    }
    constructor(creds, options = {}) {
        this.client = new aws_js_1.default.CognitoIdentityServiceProvider({ ...creds, ...options });
    }
}
exports.CognitoUserPoolClientProvider = CognitoUserPoolClientProvider;
//# sourceMappingURL=aws-cognito-client.js.map