"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleCommonSdkError = void 0;
const amplify_cli_core_1 = require("@aws-amplify/amplify-cli-core");
const commonExceptions = [
    {
        messageIndicator: /Rate Exceeded/,
        amplifyErrorType: 'APIRateExceededError',
        resolution: 'Try again later.',
    },
    {
        messageIndicator: /User: .* is not authorized to perform: .*:.* on resource: .* because no identity-based policy allows the .*:.* action/,
        amplifyErrorType: 'PermissionsError',
        resolution: 'Update the permissions.',
    },
];
const handleCommonSdkError = (error) => {
    var _a;
    for (const commonException of commonExceptions) {
        if ((_a = error.message) === null || _a === void 0 ? void 0 : _a.match(commonException.messageIndicator)) {
            return new amplify_cli_core_1.AmplifyError(commonException.amplifyErrorType, {
                message: commonException.newMessage ? commonException.newMessage : error.message,
                resolution: commonException.resolution,
            });
        }
    }
    return error;
};
exports.handleCommonSdkError = handleCommonSdkError;
//# sourceMappingURL=handle-common-sdk-errors.js.map